#include <iostream>

using namespace std;

class Register
{
    int word;
public:
    Register(int w){ word = w; }
    int getBit(int index)   // 0 <= index <= 31
    {
        return (word>>index)&1;
    }
    int getField(int index, int length)
    {
        int value = word >> index;
        int mask = 0;
        for(int i=0;i<length;i++)
            mask = (mask<<1) | 1;

        return value & mask;
    }
    string toBinaryString()
    {
        string result =  "";
        int mask = 0x80000000;  // binary1000...0
        int value = word;
        for(int k=31; k>=0; k--)
        {
            int bit = value & mask;
            if(bit)
                result += "1";
            else
                result += "0";
            value = value << 1;
        }
        return result;
    }
};
int main()
{
    Register r(5225);
    cout << r.toBinaryString() << endl;
    for(int n=0;n<=31;n++)
        cout<<n<<"\t"<<r.getBit(n)<<endl;

    cout<<r.getField(3,4)<<endl;
    return 0;
}
